/**********************************************************/
/*                                                        */
/*     AutoMap  3.00 [beta 2]                             */
/*                                                        */
/*  Version 1.1                                           */
/*  Eric Baland (AutoMap)                                 */
/*  & Koen Vrielink (AutoLink)                            */
/*    January 1997                                        */
/*                                                        */
/*  Version 2.0                                           */
/*  Jasper Peeters (AutoLink)                             */
/*    July 1997                                           */
/*                                                        */
/*  Version 2.1                                           */
/*  Martial MICHEL (AutoMap & AutoLink :                  */
/*                    Concept & Programming)              */
/*  & Delphine GOUJON (AutoLink : Concept)                */
/*    July 1998                                           */
/*                                                        */
/*  Version 2.11                                          */
/*  Martial MICHEL                                        */
/*  & Thibaut ROUFFINEAU (Testing)                        */
/*    November 1998                                       */
/*                                                        */
/*  Version 2.11.1                                        */
/*  Martial MICHEL                                        */
/*    January 1999                                        */
/*                                                        */
/*  Version 2.20                                          */
/*  Martial MICHEL                                        */
/*    June 1999                                           */
/*                                                        */
/*  Version 3.00b1                                        */
/*  Martial MICHEL                                        */
/*  & Olivier NICOLAS (Testing & AutoMap : Concept)       */
/*    April 2000                                          */
/*                                                        */
/*  Version 3.00b2                                        */
/*  Martial MICHEL                                        */
/*  & Olivier NICOLAS (Stress Testing)                    */
/*    August 2000                                         */
/*                                                        */
/**********************************************************/

#if 0
static char _AutoMap_cxx_[] = 
"@(#)[v3.00] AutoMap main code";
#endif

////////////////////////////////////////////////////////////
// Includes

////////////////////
// include yacc++ libraries
#include "yy_ansi.h"
#include "yy_stdio.h"
#include "yy_bool.h"
#include "yy_errst.h"
#include "yy_inpst.h"
#include "AM1_lex.h"
#include "AM2_lex.h"
#include "AM1_psr.h"
#include "AM2_psr.h"
#include "yy_sym.h"
#include "yy_inpfi.h"

////////////////////
// include C libraries
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

////////////////////
// Weird settings
#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS 0
#endif
#ifndef EXIT_FAILURE
#define EXIT_FAILURE 1
#endif

////////////////////
// include standard error-table for yacc++
#include "yy_err.tbl"
#ifdef yy_has_synas_
#include "yy_syna.tbl"
#else
const yy_synamsg_dflt_ptr	yy_syna_tbl = NULL;
const int			yy_syna_tbl_max_ = 0;
#endif

////////////////////////////////////////////////////////////
// Global variables

////////////////////
// Release information
float  AM_version_nbr = 3.00;
int AM_version_nbr_beta = 2; // Set to -1 for final
char AM_release_add[20] = " [beta 2]";
char AM_release[60];
char AM_blank_comment[60] =
"/********************************************************/\n";
// Typing Mark -------------------------------------------|

////////////////////
// Output files names
char AM_OP_log[20]   = "logbook.txt";
char AM_OP_AL_H[20]  = "autolink.h";
char AM_OP_AL[20]    = "al_routines.inc";
char AM_OP_AL_H2[20] = "al_routines.h";
char AM_OP_AL_H3[20] = "al_internals.h";
char AM_OP_MPI_H[20] = "mpitypes.h";
char AM_OP_MPI[20]   = "mpitypes.inc";


////////////////////
// Code information
int             code;
int             count;
int             action;
int             inc;
int             i,j,k,l, m, n, o, p;
char            *type_name;
char            name[50];
char            *dummy_name;
char            string[20];
char            line[200];
char            confirm;
decl_list_ptr   root;
declaration_ptr	decl, decl2, dummy;
storage_ptr     store;
type_ptr        tp;
init_decl_ptr   init_decl;
struct_ptr      structure;
union_ptr       unionp;
field_ptr       field;
field_type_ptr  field_type;
field_decl_ptr  field_decl;
AM2_parser      *yy_parser2;
int             AM_log = 0;
FILE            *logfile;


int	num_field,
	num_declarator,
	num_star,
	datatp,
	data,
	usertag,
	comptag,
	array,
	class_type,
	ptrs,
	ptr_path,
	to_quit_psr;

char	*type_name_ptr,
	*su_name_ptr,
	*name_ptr, 
	*fname_ptr, 
	*ident_ptr, 
        *size_ptr;

int     type_combination = 0;
int     long_count = 0;

////////////////////
// File access
FILE            *mpitypes_file;
FILE            *mpitypes_file_H;
FILE            *AL_file;
FILE            *AL_file_H2;
FILE            *AL_file_H;

////////////////////////////////////////////////////////////
// Acces Functions for the AST
//
// Tree of access to the AST :
// decl_list_ptr {num_types}
// |-> declaration_ptr {datatype, Type, sType, declaration_type,
//     |                type(), mark, pointers}
//     |-> storage_ptr {name, display_name() }
//     |-> init_decl_ptr {num_stars, name, display_name() }
//     |-> type_ptr {type_name, struct_union_name}
//         |-> struct_ptr {num_fields} -|
//         |-> union_ptr {num_fields}  -|
//             --------------------------
//             |-> field_ptr {num_declarators}
//                 |-> field_type_ptr {name}
//                 |-> field_decl_ptr {name, num_stars, is_array,
//                                     array_size, flag_name, pointer_path}

////////////////////
// Get Declaration from index in declaration list
declaration_ptr
get_declaration(decl_list_ptr from, int number)
{ /* get_declaration */
  return (from->yy_operand(number).as_declaration_ptr);
}

////////////////////
// Get Storage from Parser class STORAGE
storage_ptr
get_storage(declaration_ptr from)
{ /* get_storage */
  int i;
  
  for (i = 0; i < from->yy_num_operands()-1; i++)
    if (from->yy_operand(i).as_base_ptr->yy_type() == yy_parser2->STORAGE_)
      return (from->yy_operand(i).as_storage_ptr);
  
  return (NULL);
}

////////////////////
// Get Type from Parser information TYPE
type_ptr
get_type(declaration_ptr from)
{ /* get_type */
  int	i;
  
  for (i = 0; i < from->yy_num_operands(); i++)
    if (from->yy_operand(i).as_base_ptr->yy_type() == yy_parser2->TYPE_)
      return (from->yy_operand(i).as_type_ptr);
  
  return (NULL);
}

////////////////////
// Get information from Parser information INIT_DECLARATOR
init_decl_ptr
get_init_decl(declaration_ptr from)
{ /* get_init_decl */
  int	i;
  
  for (i = 0; i < from->yy_num_operands()-1; i++)
    if (from->yy_operand(i).as_base_ptr->yy_type() 
	== yy_parser2->INIT_DECLARATOR_)
      return (from->yy_operand(i).as_init_decl_ptr);
  
  return (NULL);
}

////////////////////
// Get Structures informations from Parser data STRUCT
struct_ptr
get_struct(type_ptr from)
{ /* get_struct */
  if (from->yy_operand(0).as_base_ptr->yy_type() == yy_parser2->STRUCT_)
    return (from->yy_operand(0).as_struct_ptr);
  
  return (NULL);
}

////////////////////
// Get Union informations from UNION in Parser
union_ptr
get_union(type_ptr from)
{ /* get_union */
  if (from->yy_operand(0).as_base_ptr->yy_type() == yy_parser2->UNION_)
    return (from->yy_operand(0).as_union_ptr);
  
  return (NULL);
}

////////////////////
// Get Fields data from index into structure data
field_ptr
get_field(struct_ptr from, int number)
{ /* get_field */
  int	i;
  int	count = 0;
  
  for (i = 0; i < from->yy_num_operands()-1; i++)
    if (from->yy_operand(i).as_base_ptr->yy_type() == yy_parser2->FIELD_)
      if (++count == number)
	return (from->yy_operand(i).as_field_ptr);
  
  return (NULL);
}

////////////////////
// Get Fields data from index into union data
field_ptr
get_field(union_ptr from, int number)
{ /*  get_field */
  int	i;
  int	count = 0;
  
  for (i = 0; i < from->yy_num_operands()-1; i++)
    if (from->yy_operand(i).as_base_ptr->yy_type() == yy_parser2->FIELD_)
      if (++count == number)
	return (from->yy_operand(i).as_field_ptr);
  
  return (NULL);
}

////////////////////
// Get Fields type from Fields
field_type_ptr
get_field_type(field_ptr from)
{ /* get_field_type */
  if (from->yy_operand(0).as_base_ptr->yy_type() == yy_parser2->FIELD_TYPE_)
    return (from->yy_operand(0).as_field_type_ptr);
  
  return (NULL);
}

////////////////////
// Get Field declarator from index
field_decl_ptr
get_field_decl(field_ptr from, int number)
{ /* get_field_decl */
  if (from->yy_operand(2*number-1).as_base_ptr->yy_type()
     == yy_parser2->FIELD_DECLARATOR_)
    return (from->yy_operand(2*number-1).as_field_decl_ptr);
  
  return (NULL);
}

////////////////////////////////////////////////////////////
// Write sub functions

////////////////////
// comparison function

int
comp_function(int type, int mask)
{ /* comp_function */
  return ((type & mask) == mask);
}


////////////////////
// Write MPI structure
int
Wr_MPI_struct(decl_list_ptr root, declaration_ptr from)
{ /* Wr_MPI_struct */
  int			i, j, k, l;
  char			*type_name, *dummy_name;
  init_decl_ptr		init_decl;
  declaration_ptr	data, dummy;
  type_ptr		type;
  struct_ptr		structure;
  field_ptr		field;
  field_type_ptr	field_type;
  field_decl_ptr	field_decl;
  int                   type_comb;
  int                   long_cnt;
  
  if (AM_log == 1) { 
    fprintf(logfile, "  * Wr_MPI_struct\n"); _AM_ff;
  }

  if (decl->type() == TYPEDEF_STRUCT_TYPE) { 
    type = get_type(from);
    type_name = type->struct_union_name;
    for (i = 0; i < root->yy_num_operands(); i++) { 
      dummy = get_declaration(root, i);
      if (dummy->type() == STRUCT_TYPE) { 
	type = get_type(dummy);
	if (strcmp(type_name, type->struct_union_name) == 0)
	  data = dummy;
      }
    }
    if (AM_log == 1) { 
      fprintf(logfile, "    - Mirror for struct declaration found\n"); _AM_ff;
    }
  } else { 
    data = from;
    if (AM_log == 1) { 
      fprintf(logfile, "    - no Mirror needed\n"); _AM_ff;
    }
  }
  
  init_decl = get_init_decl(from);
  fprintf(mpitypes_file, " /* %s */\n\n", init_decl->name);
  
  type = get_type(data);
  structure = get_struct(type);
  
  k = 0;
  for (i = 0; i < structure->num_fields; i++) { 
    if ( (field = get_field(structure, i+1)) != NULL)
      for (j = 0; j < field->num_declarators; j++) { 
	field_decl = get_field_decl(field, j+1);

	if (from->Type == 1) { 
	  if (field_decl->is_array == 1)
	    fprintf(mpitypes_file, "  MPI_Address(Type%d.%s,\t&disp[%d]);\n", 
		    from->datatype, field_decl->name, k++);
	  if (field_decl->is_array == 0)
	    fprintf(mpitypes_file, "  MPI_Address(&Type%d.%s,\t&disp[%d]);\n", 
		    from->datatype, field_decl->name, k++);
	} else if (from->sType > 0) { 
	  if (field_decl->is_array == 1)
	    fprintf(mpitypes_file, "  MPI_Address(sType%d.%s,\t&disp[%d]);\n",
		    from->datatype, field_decl->name, k++);
	  if (field_decl->is_array == 0)
	    fprintf(mpitypes_file, "  MPI_Address(&sType%d.%s,\t&disp[%d]);\n", 
		    from->datatype, field_decl->name, k++);
	}
	
      }
  }
  
  fprintf(mpitypes_file, "\n");

  k = 0;
  for (i = 0; i < structure->num_fields; i++) { 
    if ( (field = get_field(structure, i+1)) != NULL)
      for (j = 0; j < field->num_declarators; j++) { 
	field_type = get_field_type(field);
	field_decl = get_field_decl(field, j+1);
	type_name = field_type->name;
	dummy_name = new char[30];
	action = 0;
	type_comb = field_type->type_comb;
	long_cnt  = field_type->long_cnt;

	if (type_comb == 0) {
	  // It is not a default C datatype
	  strcpy(dummy_name, type_name);
	  action = 1;
	} else {
	  // It is a default C datatype
	  
	  // Note : C default is "signed"
	  // A type without specification is an int
	  
	  // char
	  if (comp_function(type_comb, _AM_CHAR))
	    if (comp_function(type_comb, _AM_UNSIGNED))
	      strcpy(dummy_name, "UNSIGNED_CHAR");
	    else
	      strcpy(dummy_name, "CHAR");
	  
	  // double
	  else if (comp_function(type_comb, _AM_DOUBLE))
	    if (comp_function(type_comb, _AM_LONG))
	      strcpy(dummy_name, "LONG_DOUBLE");
	    else
	      strcpy(dummy_name, "DOUBLE");
	  
	  // float
	  else if (comp_function(type_comb, _AM_FLOAT))
	    strcpy(dummy_name, "FLOAT");
	  
	  // int
	  else
	    // short int
	    if (comp_function(type_comb, _AM_SHORT))
	      if (comp_function(type_comb, _AM_UNSIGNED))
		strcpy(dummy_name, "UNSIGNED_SHORT");
	      else
		strcpy(dummy_name, "SHORT");
	    // long int
	    else if (comp_function(type_comb, _AM_LONG))
	      if (long_cnt == 2)
		strcpy(dummy_name, "LONG_LONG_INT");
	      else if (comp_function(type_comb, _AM_UNSIGNED))
		strcpy(dummy_name, "UNSIGNED_LONG");
	      else
		strcpy(dummy_name, "LONG");
	    // int
	    else
	      if (comp_function(type_comb, _AM_UNSIGNED))
		strcpy(dummy_name, "UNSIGNED");
	      else
		strcpy(dummy_name, "INT");
	}

	// Pointers takes it all !
	if (field_decl->num_stars != 0) { 
	  strcpy(dummy_name, "UNSIGNED_LONG");
	  action = 0;
	}
	
	if (action == 0)
	  fprintf(mpitypes_file, "  type[%d] = MPI_%s;\n", k++, dummy_name);
	else
	  fprintf(mpitypes_file, "  type[%d] = AM_%s;\n", k++, dummy_name);
      }
  }
  
  /* New method to calculate displacement array as proposed by
     Olivier Nicolas
  */

  /* Calculate "l" (Maximum number of elements in typedef) */
  l = 0;
  for (i = 0; i < structure->num_fields; i++)
    if ( (field = get_field(structure, i+1)) != NULL)
      for (j = 0; j < field->num_declarators; j++) 
	l++;
  
  /* Create "disp" */
  fprintf(mpitypes_file,
	  "\n  for (i = %d; i >= 0; i--)\n    disp[i] -= disp[0];\n\n"
	  , l - 1);
  
  /********************/
  /* Create blocklen  */

  /* Standard method */
  fprintf(mpitypes_file, "#ifndef AM_PC\n");
  k = 0;
  for (i = 0; i < structure->num_fields; i++) { 
    if ( (field = get_field(structure, i+1)) != NULL)
      for (j = 0; j < field->num_declarators; j++) {
	field_decl = get_field_decl(field, j+1);
	
	fprintf(mpitypes_file, "  blocklen[%d] = %s;\n",
		k++, field_decl->array_size);
      }
  }

  fprintf(mpitypes_file, "#else\n");

  /* Padding Correction method */
  k = 0;
  for (i = 0; i < structure->num_fields; i++) { 
    if ( (field = get_field(structure, i+1)) != NULL)
      for (j = 0; j < field->num_declarators; j++) {
	k++;
	field_decl = get_field_decl(field, j+1);

	field_type = get_field_type(field);
	type_name = field_type->name;
	
	/* Case 1 : only one element */
	if ((k == 1) && (k == l))
	  if (field_decl->num_stars != 0)
	    fprintf(mpitypes_file, 
		    "  blocklen[0] = sizeof(%s) / sizeof(unsigned long);\n",
		    init_decl->name);
	  else
	    fprintf(mpitypes_file,
		    "  blocklen[0] = sizeof(%s) / sizeof(%s);\n",
		    init_decl->name, type_name);
	
	/* Case 2 : First element (! Pointers) */
	else if (k == 1)
	  if (field_decl->num_stars != 0)
	    fprintf(mpitypes_file,
		    "  blocklen[0] = disp[1] / sizeof(unsigned long);\n");
	  else
	    fprintf(mpitypes_file,
		    "  blocklen[0] = disp[1] / sizeof(%s);\n",
		    type_name);
	
	/* Case 3 : Last Element (! Pointers) */
	else if (k == l)
	  if (field_decl->num_stars != 0)
	    fprintf(mpitypes_file,
		    "  blocklen[%d] = (sizeof(%s) - disp[%d]) / sizeof(unsigned long);\n",
		    k - 1, init_decl->name, k - 1);
	  else
	    fprintf(mpitypes_file,
		    "  blocklen[%d] = (sizeof(%s) - disp[%d]) / sizeof(%s);\n",
		    k - 1, init_decl->name, k - 1, type_name);
	
	/* Case 4 : Normal cases (! Pointers) */
	else
	  if (field_decl->num_stars != 0)
	    fprintf(mpitypes_file,
		    "  blocklen[%d] = (disp[%d] - disp[%d]) / sizeof(unsigned long);\n",
		    k - 1, k, k - 1);
	  else
	    fprintf(mpitypes_file,
		    "  blocklen[%d] = (disp[%d] - disp[%d]) / sizeof(%s);\n",
		    k - 1, k, k - 1, type_name);
      }
  }
  fprintf(mpitypes_file, "#endif\n");

  /* MPI acknoledges data-type */
  fprintf(mpitypes_file,
	  "\n  MPI_Type_struct(%d, blocklen, disp, type, &AM_%s);\n"
	  , k, init_decl->name);
  fprintf(mpitypes_file, "  MPI_Type_commit(&AM_%s);\n"
	  , init_decl->name);
  fprintf(mpitypes_file, "\n");

  return (l);
}

////////////////////
// Search Data Mirror
declaration_ptr
Search_Mirror(declaration_ptr input)
{ /* Search_Mirror */
  int		  i;
  declaration_ptr sm_decl;
  type_ptr        sm_type;
  char            *name;
  
  if (AM_log == 1) { 
    fprintf(logfile, "  * Search_Mirror\n"); _AM_ff;
  }

  if (decl->type() != TYPEDEF_STRUCT_TYPE) { 
    if (AM_log == 1) { 
      fprintf(logfile, "    - no Mirror needed\n"); _AM_ff;
    }
    
    return (input);
  }

  sm_type = get_type(input);
  name = sm_type->struct_union_name;
  
  if (AM_log == 1) { 
    fprintf(logfile, "    - First declaration datatype: %d    name: %s\n",
	    input->datatype, name); _AM_ff;
  }

  for (i = 0; i < root->yy_num_operands(); i++) { 
    /* For each declaration in decalaration list */
    sm_decl = get_declaration(root, i);
    if (AM_log == 1) { 
      fprintf(logfile, "    - Second declaration datatype: %d\n",
	      sm_decl->datatype); _AM_ff;
    }
    if ( (sm_decl->type() == TYPEDEF_STRUCT_TYPE2)
	 || (sm_decl->type() == STRUCT_TYPE) ) { 
      /* If type contains description of the structure or union */
      sm_type = get_type(sm_decl);
      if (AM_log == 1) { 
	fprintf(logfile, "    - Compare %s to %s\n"
		, name, sm_type->struct_union_name); _AM_ff;
      }
      if (sm_type->struct_union_name != NULL)
	if (strcmp(name, sm_type->struct_union_name) == 0) { 
	  if (AM_log == 1) { 
	    fprintf(logfile, "    - Match found; declaration type: %d\n"
		    , sm_decl->type()); _AM_ff;
	  }
	  return (sm_decl);
	}
    }
  }

  return (NULL);
}

////////////////////////////////////////////////////////////
// Message(s)

////////////////////
// Write Header in files
void
write_header(FILE *tmp_file)
{ /* write_header */
  fprintf(tmp_file,
	  "/**********************************************************/\n");
  fprintf(tmp_file,
	  "/*                                                        */\n");
  fprintf(tmp_file,
	  "/*     AutoMap / AutoLink 3.00 b1                         */\n");
  fprintf(tmp_file,
	  "/*                                                        */\n");
  fprintf(tmp_file,
	  "/*  version 1.1                                           */\n");
  fprintf(tmp_file,
	  "/*  Eric Baland (AutoMap)                                 */\n");
  fprintf(tmp_file,
	  "/*  & Koen Vrielink (AutoLink)                            */\n");
  fprintf(tmp_file,
	  "/*    January 1997                                        */\n");
  fprintf(tmp_file,
	  "/*                                                        */\n");
  fprintf(tmp_file,
	  "/*  Version 2.0                                           */\n");
  fprintf(tmp_file,
	  "/*  Jasper Peeters (AutoLink)                             */\n");
  fprintf(tmp_file,
	  "/*    July 1997                                           */\n");
  fprintf(tmp_file,
	  "/*                                                        */\n");
  fprintf(tmp_file,
	  "/*  Version 2.1                                           */\n");
  fprintf(tmp_file,
	  "/*  Martial MICHEL (AutoMap & AutoLink :                  */\n");
  fprintf(tmp_file,
	  "/*                    Concept & Programation)             */\n");
  fprintf(tmp_file,
	  "/*  & Delphine GOUJON (AutoLink : Concept)                */\n");
  fprintf(tmp_file,
	  "/*    July 1998                                           */\n");
  fprintf(tmp_file,
	  "/*                                                        */\n");
  fprintf(tmp_file,
	  "/*  Version 2.11                                          */\n");
  fprintf(tmp_file,
	  "/*  Martial MICHEL                                        */\n");
  fprintf(tmp_file,
	  "/*  & Thibaut ROUFFINEAU (Testing)                        */\n");
  fprintf(tmp_file,
	  "/*    November 1998                                       */\n");
  fprintf(tmp_file,
	  "/*                                                        */\n");
  fprintf(tmp_file,
	  "/*  Version 2.11.1                                        */\n");
  fprintf(tmp_file,
	  "/*  Martial MICHEL                                        */\n");
  fprintf(tmp_file,
	  "/*    January 1999                                        */\n");
  fprintf(tmp_file,
	  "/*                                                        */\n");
  fprintf(tmp_file,
	  "/*  Version 2.20                                          */\n");
  fprintf(tmp_file,
	  "/*  Martial MICHEL                                        */\n");
  fprintf(tmp_file,
	  "/*    June 1999                                           */\n");
  fprintf(tmp_file,
	  "/*                                                        */\n");
  fprintf(tmp_file,
	  "/*  Version 3.00b1                                        */\n");
  fprintf(tmp_file,
	  "/*  Martial MICHEL                                        */\n");
  fprintf(tmp_file,
	  "/*  & Olivier NICOLAS (Testing & AutoMap : Concept)       */\n");
  fprintf(tmp_file,
	  "/*    April 2000                                          */\n");
  fprintf(tmp_file,
	  "/*                                                        */\n");
  fprintf(tmp_file,
	  "/*                                                        */\n");
  fprintf(tmp_file,
	  "/**********************************************************/\n");
  fprintf(tmp_file, "\n\n\n");
}

////////////////////
// Help
void
help_base(char *AM_prog)
{ /* help_base */
  cerr << "\nLocation : "
       << AM_prog
       << endl;
}

////////////////////
// Usage
void
usage_msg()
{ /* usage_msg */
  cerr << "\nIdentification : "
       << AM_release
       << endl;

  cerr << "\nAutoMap [-help] [-v] [-log] [-noAL] filename"
       << "\n\t-help : Will print this help menu"
       << "\n\t-v    : Verbose mode"
       << "\n\t-log  : Will generate the \"logbook.txt\" for this run"
       << "\n\t-noAL : Will not generate the entries for use with AutoLink"
       << "\n\tfilename : name of the C typedef definition file to analyze"
       << endl;
}

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
// MAIN
int
main (int argc, char *argv[])
{ /* main */
  int                AM_file_argpos = 0, AM_argproc;
  int                AM_noAL = 0, AM_verbose = 0;
  int                AM_dtnumber = 0, AM_subdtnumber = 0;
  int                mf = 0; /* max fields calculation */
  yy_err_dflt_ptr    yy_err1, yy_err2;
  yy_inp_stream_ptr  yy_inp1, yy_inp2;
  yy_symtab_dflt_ptr yy_symtab1, yy_symtab2;
  AM1_lexer          *yy_lexer1;
  AM1_parser         *yy_parser1;
  AM2_lexer          *yy_lexer2;
  char               *AM_prog = argv[0];
  FILE               *AM_file_exist;
  time_t             AM_timet;
  struct tm          *AM_timetm;
  char               AM_time[100] = "", AM_argv[512];

  ////////////////////
  // Set versions number
  sprintf(AM_release, "AutoMap %2.2f%s", AM_version_nbr, AM_release_add);

  ////////////////////
  // Parse arguments
  if (argc < 2) { 
    cerr << "Error : not enough parameters"
	 << endl;
    usage_msg();
    exit (EXIT_FAILURE);
  }
  
  strcpy(AM_argv, argv[0]);
  for (i = 1; i < argc; i++) { 
    AM_argproc = 0;
    strcat(AM_argv, " ");
    strcat(AM_argv, argv[i]);
    if (strcmp(argv[i], "-help") == 0) { 
      help_base(AM_prog);
      usage_msg();
      exit (EXIT_SUCCESS);
    }
    if (strcmp(argv[i], "-noAL") == 0) { 
      AM_noAL = 1;
      AM_argproc = 1;
    }
    if (strcmp(argv[i], "-log") == 0) { 
      AM_log = 1;
      AM_argproc = 1;
    }
    if (strcmp(argv[i], "-v") == 0) { 
      AM_verbose = 1;
      AM_argproc = 1;
    }
    if (strncmp(argv[i], "-", 1) != 0) { 
      AM_file_exist = fopen(argv[i], "r");
      if (AM_file_exist == NULL) { 
	cerr << "Error : file ("
	     << argv[i]
	     << ") inexistant or wrong permissions"
	     << endl;
	exit (EXIT_FAILURE);
      }
      AM_file_argpos = i;
      AM_argproc = 1;
      fclose(AM_file_exist);
    }
    if (AM_argproc == 0) { 
      cerr << "Error : Wrong option ("
	   << argv[i]
	   << ")"
	   << endl;
      usage_msg();
      exit (EXIT_FAILURE);
    }
  }

  if (AM_file_argpos == 0) { 
    cerr << "Error : no file specified"
	 << endl;
    usage_msg();
    exit (EXIT_FAILURE);
  }

  ////////////////////
  // Version information
  if (AM_verbose == 1) { 
    cerr << "\nIdentification : "
	 << AM_release
	 << "\n\nInformation on this run : "
	 << endl;

    if (AM_noAL == 1)
      cerr << " - Will not generate AutoLink output files"
	   << endl;
    else
      cerr << " - Will generate AutoLink output files"
	   << endl;

    cerr << " - Will process file : "
	 << argv[AM_file_argpos]
	 << endl;
  }
  
  ////////////////////
  // Create log file
  if (AM_log == 1) { 
    if (AM_verbose == 1)
      cerr << "Creating AutoMap log file ... ";
    if ((logfile = fopen((const char *) AM_OP_log, "w")) == NULL) { 
      fprintf(stderr, "\n%s : Could not create log file (%s)\n",
	      AM_prog, AM_OP_log);
      exit (EXIT_FAILURE);
    }
    
    time(&AM_timet);
    AM_timetm = (struct tm *) malloc(sizeof(struct tm));
    AM_timetm = gmtime(&AM_timet);
    strftime(AM_time, 100, "%A %d %B %Y at %H:%M:%S GMT", AM_timetm);
    fprintf(logfile, "# Id : @(#)[%s] Log file (run as \'%s\' on \'%s\')\n", AM_release, AM_argv, AM_time); _AM_ff;
    
    if (AM_verbose == 1)
      cerr << "done"
	   << endl;
  }
  
  ////////////////////////////////////////////////////////////
  // Creating the AST
  if (AM_verbose == 1)
    cerr << "Creating the AST ... ";
  if (AM_log == 1) { 
    fprintf(logfile, 
	    "\n------------------------------------------------------------\nCreating the AST\n"); _AM_ff;
  }

  ////////////////////
  // Initialize Part I
  if (AM_log == 1) { 
    fprintf(logfile, "o Initialize Part I\n"); _AM_ff;
  }
  // yy_err_dflt_obj :Initializes the members of a default error 
  //   reporting object
  // (
  //   yy_err_tbl : table of error messges,
  //   yy_err_tbl_max : number of error messages in the table,
  //   yy_syna_tbl : table of syntax assists,
  //   yy_syna_tbl_max_ : number of syntax assists messages in the table,
  //   Use of "cout" to stream the error
  //  )
  yy_err1 = new yy_err_dflt_obj(yy_err_tbl, yy_err_tbl_max_,
				yy_syna_tbl, yy_syna_tbl_max_,
				&cout);
  
  // yy_inp_stream_obj : Construct an input object for reading from a stream
  yy_inp1 = new yy_inp_stream_obj(yy_err1);
  
  // yy_symtab_dflt_obj : default constructor for symbol table object
  yy_symtab1 = new yy_symtab_dflt_obj;
  
  // AM1_lexer : This is the constructor for a AM1_lexer lexer
  // (
  //  yy_inp1 : is the file object which is to be lexed
  //  yy_symtab1 : is the symbol table object to lookup keywords in
  //  last one is lexer class to create the object from
  // )
  yy_lexer1 = new AM1_lexer(yy_inp1, yy_symtab1,
			    AM1_lexer::yy_lex_class_AutoStart_);
  
  // AM1_parser : This is the constructor for a AM1_parser parser
  // (
  //  yy_lexer1 : is the lexer which will supply tokens to the parser
  //  2nd elt : is the parser class to create the object from
  //  last one : is the goal (start) symbol to parse
  // )
  yy_parser1 = new AM1_parser(yy_lexer1,
			      AM1_parser::yy_psr_class_AutoStart_,
			      AM1_parser::start_);
  
  ////////////////////
  // Initialize Part II
  if (AM_log == 1) { 
    fprintf(logfile, "o Initialize Part II\n"); _AM_ff;
  }
  // yy_err_dflt_obj :Initializes the members of a default error 
  //   reporting object (...)
  yy_err2 = new yy_err_dflt_obj(yy_err_tbl, yy_err_tbl_max_,
				yy_syna_tbl, yy_syna_tbl_max_,
				&cout);
  
  // yy_inp_stream_obj : Construct an input object for reading from a stream
  yy_inp2 = new yy_inp_stream_obj(yy_err2);
  
  // yy_symtab_dflt_obj : default constructor for symbol table object
  yy_symtab2 = new yy_symtab_dflt_obj;
  
  // AM2_lexer :  This is the constructor for a AM2_lexer lexer
  // (
  //  yy_inp2 : is the file object which is to be lexed
  //  yy_symtab2 : is the symbol table object to lookup keywords in
  //  last one : is lexer class to create the object from
  // )
  yy_lexer2 = new AM2_lexer(yy_inp2, yy_symtab2,
			    AM2_lexer::yy_lex_class_AutoMap_);
  
  // AM2_parser : This is the constructor for a AM2_parser parser
  // (
  //  yy_lexer2 : is the lexer which will supply tokens to the parser
  //  2nd elt : is the parser class to create the object from
  //  last one : is the goal (start) symbol to parse
  // )
  yy_parser2 = new AM2_parser(yy_lexer2,
			      AM2_parser::yy_psr_class_AutoMap_,
			      AM2_parser::DECLARATION_LIST_);
  
  ////////////////////
  // Read Inputfile Part I
  if (AM_log == 1) { 
    fprintf(logfile, "o Read Inputfile Part I\n"); _AM_ff;
  }
  // yy_inp_is_fstream : Return true if the file was successfully opened
  //   as the input object
  yy_inp1 -> yy_inp_is_fstream(argv[AM_file_argpos]);
  
  // yy_psr : is the driver for the parser engine which feeds it the
  //   entire source input 
  code = yy_psr(yy_parser1);
  
  ////////////////////
  // Read Inputfile Part II
  if (AM_log == 1) { 
    fprintf(logfile, "o Read Inputfile Part II\n"); _AM_ff;
  }
  // yy_inp_cur_stream : Gets the C++ stream currently opened for input
  // yy_inp_is_opened_stream : Connects an open C++ stream to an
  //   input object
  yy_inp2 -> yy_inp_is_opened_stream( yy_inp1->yy_inp_cur_stream() );
  
  // yy_psr : is the driver for the parser
  code = yy_psr(yy_parser2);
  
  // root AST
  root = yy_parser2->yy_psr_ref(1).as_decl_list_ptr;

  if (AM_verbose == 1)
    cerr << "done"
	 << endl;

  
  ////////////////////////////////////////////////////////////
  // Updating the AST
  if (AM_verbose == 1)
    cerr << "Updating the AST ... ";
  if (AM_log == 1) { 
    fprintf(logfile,
	    "\n------------------------------------------------------------\nUpdating the AST\n"); _AM_ff;
  }
  
  ////////////////////  
  // Copying Pointer information and Assigning subTypes (number)
  if (AM_log == 1) { 
    fprintf(logfile, "o Copying Pointer information and Assigning subTypes (number)\n"); _AM_ff;
  }
  
  for (i = 0; i < root->yy_num_operands(); i++) { 
    decl = get_declaration(root, i);
    tp = get_type(decl);
    structure = get_struct(tp);
    
    for (j = 0; j < structure->num_fields; j++) { 
      /* for each field in the struct */
      field = get_field(structure, j+1);
      field_type = get_field_type(field);
      
      for (k = 0; k < root->yy_num_operands(); k++) { 
	dummy = get_declaration(root, k);
	/* for each declaration in the list */
	
	if ( (init_decl = get_init_decl(dummy)) != NULL) { 
	  if (strcmp(init_decl->name, field_type->name) == 0) { 
	    /* if it is a user created declaration */
	    
	    for (l = 0; l < field->num_declarators; l++) { 
	      
	      /* Set the number of stars of this field */
	      field_decl = get_field_decl(field, l+1);
	      field_decl->num_stars += init_decl->num_stars;
	      
	      /* Set the fact that it is a subType (not a user Type) */
	      if (dummy->Type == 0) { 
		/* if it is the first time for this subType,
		   set its datatype number */
		if (dummy->sType == 0)
		  dummy->sType = 1;
		/* if it is used with pointers, tell the subType */
		if (field_decl->num_stars != 0)
		  dummy->sType = 2;
	      }
	    }
	  }
	}
      }
    }
  }
  
  ////////////////////  
  // Assigning Datatype Numbers
  if (AM_log == 1) { 
    fprintf(logfile, "o Assigning Datatype Numbers\n"); _AM_ff;
  }

  /* First AutoLink types */
  for (i = 0; i < root->yy_num_operands(); i++) { 
    decl = get_declaration(root, i);
    if ((decl->Type == 1) || (decl->sType == 2)) { 
      /* The definition is to be used by AL */
      decl->datatype = AM_dtnumber;
      AM_dtnumber++;
    } else { 
      decl->datatype = -1;
    }
  }

  /* AM subTypes then */
  AM_subdtnumber = AM_dtnumber;
  for (i = 0; i < root->yy_num_operands(); i++) { 
    decl = get_declaration(root, i);
    if (decl->sType == 1) { /* else if */
      /* it is an AM subType */
      decl->datatype = AM_subdtnumber;
      AM_subdtnumber++;
    }
  }

  ////////////////////
  // Tracking Pointer Paths
  if (AM_log == 1) { 
    fprintf(logfile, "o Tracking Pointer Paths\n"); _AM_ff;
  }

  for (i = 0; i < root->yy_num_operands(); i++) { 
    decl = get_declaration(root, i);
    if ( (decl->type() == TYPEDEF_STRUCT_TYPE2) 
	 || (decl->type() == STRUCT_TYPE) ) { 
      /* If declaration contains the structure fields declaration */

      tp = get_type(decl);
      structure = get_struct(tp);
      
      /* For all the fields in this structure declaration */
      for (j = 0; j < structure->num_fields; j++) { 
	field = get_field(structure, j+1);
	field_type = get_field_type(field);

	for (k = 0; k < root->yy_num_operands(); k++) { 
	  decl2 = get_declaration(root, k);
	  if ( (init_decl = get_init_decl(decl2)) != NULL) { 
	    if (strcmp(init_decl->name, field_type->name) == 0) { 
	      for (l = 0; l < field->num_declarators; l++) { 
		field_decl = get_field_decl(field, l+1);
		if (field_decl->num_stars != 0) { 
		  /* Set the declaration as a pointer field if necessary */
		  decl->pointers = 1;
		} 
	      }
	    }
	  }
	}
      }
    }
  }
  
  inc = 0;
  action = 1;
  while (action != 0) { /* while */
    /* While there is some pointers unset in any declaration */
    action = 0;
    inc++;
    for (i = 0; i < root->yy_num_operands(); i++) { 
      decl = get_declaration(root, i);
      /* for each declaration in declaration list */
      
      if ( (decl->type() == TYPEDEF_STRUCT_TYPE2) 
	   || (decl->type() == STRUCT_TYPE) ) { 
	/* If declaration contains structure fields */
	
	tp = get_type(decl);
	structure = get_struct(tp);
	for (j = 0; j < structure->num_fields; j++) { 
	  field = get_field(structure, j+1);
	  field_type = get_field_type(field);
	  /* For each field in the structure */

	  for (k = 0; k < root->yy_num_operands(); k++) { 
	    decl2 = get_declaration(root, k);
	    if ( (init_decl = get_init_decl(decl2)) != NULL) { 
	      if (strcmp(init_decl->name, field_type->name) == 0) { 
		/* If field is a the currently browsed user defined type */
		for (l = 0; l < field->num_declarators; l++) { 
		  /* for each field of the structure */
		  field_decl = get_field_decl(field, l+1);
		  if (field_decl->num_stars == 0) { 
		    /* if the field has no star */
		    if (decl2->pointers == 1) { 
		      /* but the new type is accessed by pointer */
		      if (field_decl->pointer_path == 0) { 
			/* then the field is called by pointer */
			field_decl->pointer_path = 1;
			decl->pointers = 1;
			action = 1;
		      }
		    }
		  }
		}
	      }
	    }
	  }
	}
      }
    }
  }
  
  if (AM_verbose == 1)
    cerr << "done"
	 << endl;

  ////////////////////////////////////////////////////////////
  // Writing mpitypes.inc (& mpitypes.h)
  if (AM_verbose == 1)
    cerr << "Writing mpitypes.inc (& mpitypes.h) ... ";
  if (AM_log == 1) { 
    fprintf(logfile, "\n------------------------------------------------------------\nWriting mpitypes.inc (& mpitypes.h)\n"); _AM_ff;
  }

  ////////////////////
  // Write MPI types main file
  if (AM_log == 1) { 
    fprintf(logfile, "o Write MPI types main file\n"); _AM_ff;
  }
  
  if ((mpitypes_file = fopen((const char *) AM_OP_MPI, "w")) == NULL) { 
    fprintf(stderr, "%s : Could not create %s \n",
	    AM_prog, AM_OP_MPI);
    exit (EXIT_FAILURE);

  }
  if ((mpitypes_file_H = fopen((const char *) AM_OP_MPI_H, "w")) == NULL) { 
    fprintf(stderr, "%s : Could not create %s \n",
	    AM_prog, AM_OP_MPI_H);
    exit (EXIT_FAILURE);
  }

  write_header(mpitypes_file);
  write_header(mpitypes_file_H);

  fprintf(mpitypes_file, "#if 0\nstatic char _mpitypes_inc_[] =\n\"@(#)[%s] AutoMap MPI Types (created by \'%s\' on \'%s\')\";\n#endif\n\n", AM_release, AM_argv, AM_time);
  
  ////////////////////
  // Prototype file mutual exclusion
  fprintf(mpitypes_file_H, "#ifndef __MPITYPES_H__\n");
  fprintf(mpitypes_file_H, "#define __MPITYPES_H__\n");
  fprintf(mpitypes_file_H, "\n");

  fprintf(mpitypes_file, "#define __MPITYPES_INC__\n");
  fprintf(mpitypes_file, "\n");

  fprintf(mpitypes_file_H, "#if 0\nstatic char _mpitypes_h_[] =\n\"@(#)[%s] AutoMap MPI Types (created by \'%s\' on \'%s\')\";\n#endif\n\n", AM_release, AM_argv, AM_time);

  ////////////////////
  // Used definitions
  fprintf(mpitypes_file, "#include \"%s\"\n\n", AM_OP_MPI_H);
  if (AM_noAL == 0) { 
    fprintf(mpitypes_file_H, "\n/* Number of used types */\n#define _AL_TpUsed      %d\n\n", AM_dtnumber);
    fprintf(mpitypes_file, "MPI_Datatype        _AM_Types[_AL_TpUsed];\n\n");
  }

  ////////////////////
  // First the subTypes
  if (AM_log == 1) { 
    fprintf(logfile, "o First the subTypes\n"); _AM_ff;
  }
  fprintf(mpitypes_file_H,"/* subTypes (if any) */\n");
  fprintf(mpitypes_file,"/* subTypes (if any) */\n");
  for (i = 0; i < root->yy_num_operands(); i++) { 
    /* for each declaration in declaration list */
    decl = get_declaration(root,i);
    if (decl->sType > 0) { 
      /* if declaration is used by an AM type */
      /* The new type is "AM_" followed by the name of the declaration */
      init_decl = get_init_decl(decl);
      fprintf(mpitypes_file_H, "extern MPI_Datatype        AM_%s;\n",
	      init_decl->name);
      fprintf(mpitypes_file, "MPI_Datatype        AM_%s;\n", init_decl->name);
    }
  }
  
  ////////////////////
  // Then the AM declared types
  if (AM_log == 1) { 
    fprintf(logfile, "o Then the AM declared types\n"); _AM_ff;
  }
  fprintf(mpitypes_file_H, "\n/* userTypes */\n");
  fprintf(mpitypes_file, "\n/* userTypes */\n");
  for (i = 0; i < root->yy_num_operands(); i++) { 
    /* for each declaration in declaration list */
    decl = get_declaration(root, i);
    if (decl->Type == 1) {  
      /* if this is an AM declared type */
      init_decl = get_init_decl(decl);
      fprintf(mpitypes_file_H, "extern MPI_Datatype         AM_%s;\n",
	      init_decl->name);
      fprintf(mpitypes_file, "MPI_Datatype         AM_%s;\n",
	      init_decl->name);
    }
  }
  
  ////////////////////
  // Include the prototypes definition
  fprintf(mpitypes_file_H, "\n/* Prototypes definition */\n");
  fprintf(mpitypes_file_H, "void Build_MPI_Types();\n");
  fprintf(mpitypes_file_H, "void Free_MPI_Types();\n");

  ////////////////////
  // Create "Build_MPI_Types()"
  if (AM_log == 1) { 
    fprintf(logfile, "o Create \"Build_MPI_Types()\"\n"); _AM_ff;
  }

  fprintf(mpitypes_file, "void\nBuild_MPI_Types()\n");
  fprintf(mpitypes_file, "{\n");
  
  for (i = 0; i < root->yy_num_operands(); i++) { 
    /* for each declaration in the declaration list */
    decl = get_declaration(root, i);
    if (decl->sType > 0) { 
      /* if declaration is an AM sub Type */
      /* we are going to use "sType" defintions */
      init_decl = get_init_decl(decl);
      fprintf(mpitypes_file, "  %s sType%d;\n",
	      init_decl->name, decl->datatype);
    }
  }
  
  fprintf(mpitypes_file, "\n");
  for (i = 0; i < root->yy_num_operands(); i++) { 
    /* for each declaration in declaration list */
    decl = get_declaration(root, i);
    if (decl->Type == 1) { 
      /* if declaration is an AM type */
      /* we are going to create "Type" definitions */
      init_decl = get_init_decl(decl);
      fprintf(mpitypes_file,
	      "  %s Type%d;\n",init_decl->name, decl->datatype);
    }
  }
  fprintf(mpitypes_file, "\n");
  
  ////////////////////
  // Used Variables
  if (AM_log == 1) { 
    fprintf(logfile, "o Used Variables\n"); _AM_ff;
  }

  fprintf(mpitypes_file, "  MPI_Aint          disp[_AM_MaxFields];\n");
  fprintf(mpitypes_file, "  MPI_Datatype      type[_AM_MaxFields];\n");
  fprintf(mpitypes_file, "  int               blocklen[_AM_MaxFields];\n");
  fprintf(mpitypes_file, "  int               i;\n");
  fprintf(mpitypes_file, "\n");
  
  ////////////////////
  // Writting all types
  if (AM_log == 1) { 
    fprintf(logfile, "o Writing all types\n"); _AM_ff;
  }

  /* First for all sub Types */
  for (i = 0; i < root->yy_num_operands(); i++) { 
    /* for all declaration in declaration list */
    decl = get_declaration(root, i);
    if (decl->sType > 0) {
      /* If type is an AM sub Type */
      int mmf;
      mmf = Wr_MPI_struct(root, decl);
      if (mmf > mf) mf = mmf;
    }
  }
  
  /* Then for all AM types */
  for (i = 0; i < root->yy_num_operands(); i++) { 
    /* for each declaration in declaration list */
    decl = get_declaration(root, i);
    if (decl->Type == 1) { 
      /* if declaration is of an AM type */
      int mmf;
      mmf = Wr_MPI_struct(root, decl);
      if (mmf > mf) mf = mmf;
    }
  }
  
  ////////////////////
  // _AM_MaxFields creation
  fprintf(mpitypes_file_H, "\n/* MaxFields entry */\n#define _AM_MaxFields   %d\n\n", mf);

  ////////////////////
  // Prototype file mutual exclusion
  fprintf(mpitypes_file_H, "\n#endif /* __MPITYPES_H__ */\n");

  ////////////////////
  // Closing mpitypes.h
  fclose(mpitypes_file_H);

  if (AM_log == 1) { 
      fprintf(logfile, "o Close file %s\n", AM_OP_MPI_H); _AM_ff;
    }
  
  ////////////////////
  // Write type creation array
  if (AM_noAL == 0) { 
    if (AM_log == 1) { 
      fprintf(logfile, "o Write type creation array\n"); _AM_ff;
    }
    
    for (i = 0; i < root->yy_num_operands(); i++) { 
      decl = get_declaration(root, i);
      if ((decl->Type == 1) || (decl->sType == 2)) { 
	init_decl = get_init_decl(decl);
	fprintf(mpitypes_file, "  _AM_Types[%d] = AM_%s;\n",
		decl->datatype, init_decl->name);
      }
    }
  }

  // End function
  fprintf(mpitypes_file, "}\n");


  ////////////////////
  // Create "Free_MPI_Types()"
  if (AM_log == 1) { 
    fprintf(logfile, "o Create \"Free_MPI_Types()\"\n"); _AM_ff;
  }

  fprintf(mpitypes_file, "\nvoid\nFree_MPI_Types()\n");
  fprintf(mpitypes_file, "{\n");
  for (i = 0; i < root->yy_num_operands(); i++) { 
    decl = get_declaration(root, i);
    if ((decl->Type == 1) || (decl->sType == 2)) { 
      init_decl = get_init_decl(decl);
      fprintf(mpitypes_file, "  MPI_Type_free(&AM_%s);\n", init_decl->name);
    }
  }
  
  // End function
  fprintf(mpitypes_file, "}\n");

  ////////////////////
  // Closing mpitypes.inc
  fclose(mpitypes_file);
  
  if (AM_verbose == 1)
    cerr << "done"
	 << endl;
  
  ///////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////
  // AutoLink code generation

  ////////////////////////////////////////////////////////////
  // Writing al_routines.inc, al_routines.h, autolink.h
  if (AM_noAL == 0) { 
    
    if (AM_verbose == 1)
      cerr << "Writing al_routines.inc, al_routines.h, autolink.h ... ";
    if (AM_log == 1) { 
      fprintf(logfile, "\n------------------------------------------------------------\nWriting al_routines.inc (& autolink.h)\n"); _AM_ff;
    }

    ////////////////////
    // Write AL routines file
    if (AM_log == 1) { 
      fprintf(logfile, "o Write AL routines fileS\n"); _AM_ff;
    }

    if ((AL_file = fopen((const char *) AM_OP_AL, "w")) == NULL) { 
      fprintf(stderr, "%s : Could not create %s \n",
	      AM_prog, AM_OP_AL);
      exit (EXIT_FAILURE);
    }

    if ((AL_file_H2 = fopen((const char *) AM_OP_AL_H2, "w")) == NULL) { 
      fprintf(stderr, "%s : Could not create %s \n",
	      AM_prog, AM_OP_AL);
      exit (EXIT_FAILURE);
    }

    if ((AL_file_H = fopen((const char *) AM_OP_AL_H, "w")) == NULL) { 
      fprintf(stderr, "%s : Could not create %s \n",
	      AM_prog, AM_OP_AL_H);
      exit (EXIT_FAILURE);
    }

    write_header(AL_file);
    write_header(AL_file_H2);
    write_header(AL_file_H);

    fprintf(AL_file, "#if 0\nstatic char _al_routines_inc_[] =\n\"@(#)[%s] AutoLink autogenerated include file (created by \'%s\' on \'%s\')\";\n#endif\n\n", AM_release, AM_argv, AM_time);

    fprintf(AL_file_H2, "#ifndef  __AL_ROUTINES_H__\n");
    fprintf(AL_file_H2, "#define  __AL_ROUTINES_H__\n\n");

    fprintf(AL_file_H2, "#if 0\nstatic char _al_routines_h_[] =\n\"@(#)[%s] AutoLink autogenerated prototypes file (created by \'%s\' on \'%s\')\";\n#endif\n\n", AM_release, AM_argv, AM_time);

    fprintf(AL_file_H, "#ifndef  __AUTOLINK_H__\n");
    fprintf(AL_file_H, "#define  __AUTOLINK_H__\n\n");

    fprintf(AL_file_H, "#if 0\nstatic char _autolink_h_[] =\n\"@(#)[%s] AutoLink autogenerated prototypes file (created by \'%s\' on \'%s\')\";\n#endif\n\n", AM_release, AM_argv, AM_time);

    fprintf(AL_file_H, "#define AMVERSION %d\n\n", (int) (AM_version_nbr * 100.0));
    fprintf(AL_file_H, "#define AMVERSION_BETA %d\n\n", AM_version_nbr_beta);

    if (AM_log == 1) { 
      fprintf(logfile, "o %d elements to check\n",root->yy_num_operands()); _AM_ff;
    }

    ////////////////////
    // autolink.h should include al_internals.h
    fprintf(AL_file_H, "#include <%s>\n", AM_OP_AL_H3);

    ////////////////////
    // Validate types for AutoLink internal use
    if (AM_log == 1) { 
      fprintf(logfile, "o Validate types for AutoLink internal use\n"); _AM_ff;
    }

    fprintf(AL_file_H, "\n\n%s", AM_blank_comment);
    fprintf(AL_file_H, 
	    /********************************************************/
	    "/*     Validate types for internal use                  */\n");
    fprintf(AL_file_H, "%s", AM_blank_comment);
    
    ////////////////////
    // First the subTypes
    if (AM_log == 1) { 
      fprintf(logfile, "o First the subTypes\n"); _AM_ff;
    }
    fprintf(AL_file, "/* subTypes (if any) */\n");
    fprintf(AL_file_H, "/* subTypes (if any) */\n");

    for (i = 0; i < root->yy_num_operands(); i++) { 
      decl = get_declaration(root, i);
      /* for each declaration in declaration list */
      
      if (decl->sType == 2) { 
	/* if declaration is an AM defined subType */
	
	init_decl = get_init_decl(decl);
	fprintf(AL_file, "typedef %s AL_Tp%d;\n",
		init_decl->name, decl->datatype);
	fprintf(AL_file_H, "#define AL_%s %d\n",
		init_decl->name, decl->datatype);
      }
    }

    ////////////////////
    // Then, user Types
    if (AM_log == 1) { 
      fprintf(logfile, "o Then the AM declared types\n"); _AM_ff;
    }
    fprintf(AL_file, "\n/* userTypes */\n");
    fprintf(AL_file_H, "\n/* userTypes */\n");

    for (i = 0; i < root->yy_num_operands(); i++) { 
      decl = get_declaration(root, i);
      /* for each declaration in declaration list */
      
      if (decl->Type == 1) { 
	/* if decclaration is an AM defined type */
	
	init_decl = get_init_decl(decl);
	fprintf(AL_file, "typedef %s AL_Tp%d;\n",
		init_decl->name, decl->datatype);
	fprintf(AL_file_H, "#define AL_%s %d\n",
		init_decl->name, decl->datatype);
      }
    }

    ////////////////////
    // Include the prototypes definition
    fprintf(AL_file_H,
	    "\n/* AutoLink prototypes definition */\n");
    fprintf(AL_file_H,
	    "void AL_Init(int packetsize);\n");
    fprintf(AL_file_H,
	    "void AL_Finalize();\n");

    fprintf(AL_file_H,
	    "\n/* AutoLink added functions */\n");
    fprintf(AL_file_H,
	    "int AL_LogEntry(char *entry);\n");
    fprintf(AL_file_H,
	    "int AL_SetPacketSize(int size);\n");
    fprintf(AL_file_H,
	    "void AL_Free(AL_ReqList** rqlist);\n");

    fprintf(AL_file_H,
	    "\n/* AutoLink blocking operations */\n");
    fprintf(AL_file_H,
	    "int AL_Send(void* buf, int datatype, int dest, int tag, MPI_Comm comm);\n");
    fprintf(AL_file_H,
	    "int AL_Recv(void** buf, int* datatype, int source, int tag, MPI_Comm comm, MPI_Status* status, AL_ReqList** rqlist);\n");

    fprintf(AL_file_H,
	    "\n/* AutoLink non blocking operations */\n");
    fprintf(AL_file_H,
	    "int AL_ISend(void* buf, int datatype, int dest, int tag, MPI_Comm comm, AL_ISendRL** rlist);\n");
    fprintf(AL_file_H,
	    "int AL_ISendTest(AL_ISendRL **rlist);\n");
    fprintf(AL_file_H,
	    "int AL_ISendWait(AL_ISendRL **rlist);\n");
    fprintf(AL_file_H,
	    "int AL_ISendComplete(AL_ISendRL **rlist);\n");
    //fprintf(AL_file_H,
    //"int AL_ISendCancel(AL_ISendRL **rlist);\n");
    fprintf(AL_file_H,
	    "int AL_IRecv(void** buf, int* datatype, int source, int tag, MPI_Comm comm, AL_IRecvRL** rlist, AL_ReqList** rqlist);\n");
    fprintf(AL_file_H,
	    "int AL_IRecvTest(AL_IRecvRL **rlist);\n");
    fprintf(AL_file_H,
	    "int AL_IRecvWait(AL_IRecvRL **rlist);\n");
    fprintf(AL_file_H,
	    "int AL_IRecvComplete(AL_IRecvRL **rlist);\n");
    //fprintf(AL_file_H,
    //"int AL_IRecvCancel(AL_IRecvRL **rlist);\n");

    ////////////////////
    // Prototype file mutual exclusion
    fprintf(AL_file_H, "\n#endif /* __AUTOLINK_H__ */\n");

    ////////////////////
    // Closing mpitypes.h
    fclose(AL_file_H);
    fprintf(AL_file, "\n");

    if (AM_log == 1) { 
      fprintf(logfile, "o Close file %s\n", AM_OP_AL_H); _AM_ff;
    }

    ////////////////////
    // Write _AL_PrepareBuffer
    if (AM_log == 1) { 
      fprintf(logfile, "o Write _AL_PrepareBuffer\n"); _AM_ff;
    }

    fprintf(AL_file, "#include <%s>\n\n", AM_OP_AL_H2);

    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file, 
    	    /********************************************************/
	    "/*     _AL_PrepareBuffer                                */\n");
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file_H2, "void\n(* _AL_PrepareBuffer[_AL_TpUsed])();\n\n");
    for (i = 0; i < AM_dtnumber; i++) { 
      fprintf(AL_file, "void\n_AL_PrepareBuffer%d(AL_Internals *ALint)\n", i);
      fprintf(AL_file, "{ /* _AL_PrepareBuffer%d */\n", i);
      fprintf(AL_file, "  AL_DataBlocks[%d] = AL_Blocks_Create(AL_PacketSize[%d] * sizeof(AL_Tp%d), AL_BLOCKS_NUMBER);\n", i, i, i);
      fprintf(AL_file, "} /* _AL_PrepareBuffer%d */\n\n", i);
    }

    ////////////////////
    // Write _AL_GetBlockBuffer
    if (AM_log == 1) { 
      fprintf(logfile, "o Write _AL_GetBlockBuffer\n"); _AM_ff;
    }
    
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file, 
    	    /********************************************************/
	    "/*     _AL_GetBlockBuffer                              */\n");
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file_H2, "void\n(* _AL_GetBlockBuffer[_AL_TpUsed])();\n\n");
    for (i = 0; i < AM_dtnumber; i++) { 
      fprintf(AL_file, "void\n_AL_GetBlockBuffer%d(AL_Internals *ALint)\n", i);
      fprintf(AL_file, "{ /* _AL_GetBlockBuffer%d */\n", i);
      fprintf(AL_file, "  ALint->AL_Data[%d] = (AL_Tp%d *) AL_Blocks_GetBlock(&AL_DataBlocks[%d]);\n", i, i, i);
      fprintf(AL_file, "} /* _AL_GetBlockBuffer%d */\n\n", i);
    }

    ////////////////////
    // Write _AL_GiveBlockBuffer
    if (AM_log == 1) { 
      fprintf(logfile, "o Write _AL_GiveBlockBuffer\n"); _AM_ff;
    }
    
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file, 
    	    /********************************************************/
	    "/*     _AL_GiveBlockBuffer                             */\n");
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file_H2, "void\n(* _AL_GiveBlockBuffer[_AL_TpUsed])();\n\n");
    for (i = 0; i < AM_dtnumber; i++) { 
      fprintf(AL_file, "void\n_AL_GiveBlockBuffer%d(AL_Internals *ALint)\n", i);
      fprintf(AL_file, "{ /* _AL_GiveBlockBuffer%d */\n", i);
      fprintf(AL_file, "  AL_Blocks_GiveBlock(&AL_DataBlocks[%d], ALint->AL_Data[%d]);\n", i, i);
      fprintf(AL_file, "} /* _AL_GiveBlockBuffer%d */\n\n", i);
    }
    
    ////////////////////
    // Write _AL_GetBlockElement

    if (AM_log == 1) { 
      fprintf(logfile, "o Write _AL_GetBlockElement\n"); _AM_ff;
    }

    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file, 
	    /********************************************************/
	    "/*     _AL_GetBlockElement                                    */\n");
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file_H2, "void*\n(* _AL_GetBlockElement[_AL_TpUsed])();\n\n");
    
    for (i = 0; i < AM_dtnumber; i++) { 
      fprintf(AL_file,
	      "void *\n_AL_GetBlockElement%d(int column, AL_Internals *ALint)\n", i);
      fprintf(AL_file, "{ /* _AL_GetBlockElement%d */\n", i);
      fprintf(AL_file, "  AL_Tp%d *tmp;\n\n", i);
      fprintf(AL_file, "  tmp = &(((AL_Tp%d *) ALint->AL_Data[%d])[column]);\n", i, i);
      fprintf(AL_file, "  return ((void *) tmp);\n");
      fprintf(AL_file, "} /* _AL_GetBlockElement%d */\n\n", i);
    }
    
    ////////////////////
    // Write _AL_MemCreate
    if (AM_log == 1) { 
      fprintf(logfile, "o Write _AL_MemCreate\n"); _AM_ff;
    }

    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file, 
	    /********************************************************/
	    "/*     _AL_MemCreate                                    */\n");
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file_H2, "void*\n(* _AL_MemCreate[_AL_TpUsed])();\n\n");
    
    for (i = 0; i < AM_dtnumber; i++) { 
      fprintf(AL_file,
	      "void *\n_AL_MemCreate%d(int line, int column, AL_Internals *ALint)\n", i);
      fprintf(AL_file, "{ /* _AL_MemCreate%d */\n", i);
      fprintf(AL_file, "  AL_Tp%d *tmp, *tmp2;\n\n", i);
      fprintf(AL_file, "  tmp = (AL_Tp%d *) malloc(sizeof(AL_Tp%d));\n", i, i);
      fprintf(AL_file,
	      "  tmp2 = &(((AL_Tp%d *) ALint->AL_Data[line])[column]);\n", i);
      fprintf(AL_file,
	      "  *tmp = *tmp2;\n\n");
      fprintf(AL_file, "  return ((void *) tmp);\n");
      fprintf(AL_file, "} /* _AL_MemCreate%d */\n\n", i);
    }
    
    ////////////////////
    // Write _AL_Traverse
    if (AM_log == 1) { 
      fprintf(logfile, "o Write _AL_Traverse\n"); _AM_ff;
    }

    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file, 
	    /********************************************************/
	    "/*     _AL_Traverse                                     */\n");
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file_H2, "void\n(* _AL_Traverse[_AL_TpUsed])();\n\n");
    
    for (i = 0; i < root->yy_num_operands(); i++) { 
      decl = get_declaration(root, i);
      /* for each declaration in declaration list */
      
      if ((decl->Type == 1) || (decl->sType == 2)) { 
	/* if decclaration is an AM defined type */

	j = decl->datatype;
	fprintf(AL_file,
		"void\n_AL_Traverse%d(AL_Tp%d *content, AL_Internals *ALint)\n", j, j);
	fprintf(AL_file, "{ /* _AL_Traverse%d */\n", j);

	/* Find  and get the real structure inside */
	decl2 = Search_Mirror(decl);
	tp = get_type(decl2);
	structure = get_struct(tp);
	for (k = 0; k < structure->num_fields; k++) { 
	  field = get_field(structure, k+1);
	  field_type = get_field_type(field);
	  for (l = 0; l < field->num_declarators; l++) { 
	    field_decl = get_field_decl(field, l+1);
	    /* Now if the it is a pointer ... */
	    if (field_decl->num_stars != 0) { 
	      for (m = 0; m < root->yy_num_operands(); m++) { 
		dummy = get_declaration(root, m);
		if ( (init_decl = get_init_decl(dummy)) != NULL ) {
		  if (strcmp(init_decl->name, field_type->name) == 0) { 
		    /* And it is a type we know of */
		    
		    /* It is an array of pointers */
		    if (field_decl->is_array == 1) {
		      fprintf(AL_file, "  {\n    int i;\n\n");
		      fprintf(AL_file,
			      "    for (i = 0; i < %s; i++) {\n",
			      field_decl->array_size);

		    /* If child has not been marked AND exists */
		    fprintf(AL_file,
			    "      if ((content->%s[i] != NULL) && (AL_HT_Search(ALint->AL_Mark, (unsigned long int) content->%s[i]) == -1)) {\n"
			    , field_decl->name, field_decl->name);
		     fprintf(AL_file,
			     "         int tmp;\n");
		     
		    /* Add &CHILD in ADDRESS */
		    fprintf(AL_file,
			    "          tmp = AL_SArray_AddLast(&(ALint->AL_Address), %d, content->%s[i]);\n", dummy->datatype, field_decl->name);
		    
		    /* Add CHILD in NEXT */
		    fprintf(AL_file,
			    "          AL_Queue_Add(ALint->AL_Next, %d, tmp);\n",
			    dummy->datatype);
		    
		    /* Mark CHILD node */
		    fprintf(AL_file,
			    "          AL_HT_Add(ALint->AL_Mark, (unsigned long int) content->%s[i], tmp);\n",
			    field_decl->name);
		    
		    /* Endif (1) */
		    fprintf(AL_file, "      }\n");

		    /* End for */
		    fprintf(AL_file, "    }\n  }\n\n");
		    } else {
		      /* It is not an array of pointers */

		      /* If child has not been marked AND exists */
		      fprintf(AL_file,
			      "  if ((content->%s != NULL) && (AL_HT_Search(ALint->AL_Mark, (unsigned long int) content->%s) == -1)) {\n    int tmp;"
			      , field_decl->name, field_decl->name);
		      
		      /* Add &CHILD in ADDRESS */
		      fprintf(AL_file,
			      "      tmp = AL_SArray_AddLast(&(ALint->AL_Address), %d, content->%s);\n", dummy->datatype, field_decl->name);
		      
		      /* Add CHILD in NEXT */
		      fprintf(AL_file,
			      "      AL_Queue_Add(ALint->AL_Next, %d, tmp);\n",
			      dummy->datatype);
		      
		      /* Mark CHILD node */
		      fprintf(AL_file,
			      "      AL_HT_Add(ALint->AL_Mark, (unsigned long int) content->%s, tmp);\n",
			      field_decl->name);
		      
		      /* Endif (1) */
		      fprintf(AL_file, "  }\n\n");
		    }
		  }
		}
	      }
	    }
	  }
	}
	fprintf(AL_file, "} /* _AL_Traverse%d */\n\n", j);
      }
    }

    ////////////////////
    // Write _AL_CopyAdapt

    if (AM_log == 1) { 
      fprintf(logfile, "o Write _AL_CopyAdapt\n"); _AM_ff;
    }

    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file, 
    	    /********************************************************/
    	    "/*     _AL_CopyAdapt                                   */\n");
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file_H2, "int\n(* _AL_CopyAdapt[_AL_TpUsed])();\n\n");
    
    for (i = 0; i < root->yy_num_operands(); i++) { 
      decl = get_declaration(root, i);
      /* for each declaration in declaration list */
      
      if ((decl->Type == 1) || (decl->sType == 2)) { 
	/* if decclaration is an AM defined type */
	int contentcopyused = 0;

	j = decl->datatype;
   
	fprintf(AL_file, "int\n_AL_CopyAdapt%d(AL_Tp%d* content, AL_Internals *ALint)\n", j, j);
	fprintf(AL_file, "{ /* _AL_CopyAdapt%d */\n", j);
	
	/* Find and get the real structure inside */
	decl2 = Search_Mirror(decl);
	tp = get_type(decl2);
	structure = get_struct(tp);
	for (k = 0; k < structure->num_fields; k++) { 
	  field = get_field(structure, k+1);
	  field_type = get_field_type(field);
	  for (l = 0; l < field->num_declarators; l++) { 
	    field_decl = get_field_decl(field, l+1);
	    /* Now if the it is a pointer ... */
	    if (field_decl->num_stars != 0) { 
	      for (m = 0; m < root->yy_num_operands(); m++) { 
		dummy = get_declaration(root, m);
		if ( (init_decl = get_init_decl(dummy)) != NULL ) { /*if */
		  if (strcmp(init_decl->name, field_type->name) == 0) { 
		    /* And it is a type we know of */

		    /* First let's Create a temporary copy to work with */
		    if (contentcopyused == 0) {
		      fprintf(AL_file, "  AL_Tp%d *contentcopy;\n\n", j);

		      fprintf(AL_file, "  ((AL_Tp%d *) ALint->AL_Data[%d])[ALint->AL_DataCount[%d]] = *((AL_Tp%d *) content);\n\n", j, j, j, j);
	
		      fprintf(AL_file, "  contentcopy = &((AL_Tp%d *) ALint->AL_Data[%d])[ALint->AL_DataCount[%d]];\n\n", j, j, j);

		      contentcopyused = 1;
		    }

		    /* It is an array of pointers */
		    if (field_decl->is_array == 1) {
		      fprintf(AL_file, "  {\n    int i;\n\n");

		      fprintf(AL_file,
			      "    for (i = 0; i < %s; i++) {\n",
			      field_decl->array_size);
		      
		      /* if child does not exist */
		      fprintf(AL_file,
			      "      if (content->%s[i] == NULL) {\n",
			      field_decl->name);
		      
		      /* Then Add NO_CHILD in LINKS (copy of object in PACKET) */
		      fprintf(AL_file,
			      "        contentcopy->%s[i] = (void *) AL_NOCHILD;\n",
			      field_decl->name);
		    
		      /* Else (child do exist) */
		      fprintf(AL_file,
			      "      } else {\n");
		      
		      /* Set value of links (copy) */
		      fprintf(AL_file,
			      "        contentcopy->%s[i] = (void *) AL_HT_Search(ALint->AL_Mark, (unsigned long int) content->%s[i]);\n",
			      field_decl->name, field_decl->name); 
		      
		      /* Endif (1) */
		      fprintf(AL_file, "      }\n");

		      /* End for */
		      fprintf(AL_file, "    }\n  }\n\n");
		    } else {
		      /* It is not an array of pointers*/

		      /* if child does not exist */
		      fprintf(AL_file,
			      "  if (content->%s == NULL) {\n",
			      field_decl->name);
		      
		      /* Then Add NO_CHILD in LINKS (copy of object in PACKET) */
		      fprintf(AL_file,
			      "    contentcopy->%s = (void *) AL_NOCHILD;\n",
			      field_decl->name);
		      
		      /* Else (child do exist) */
		      fprintf(AL_file,
			      "  } else {\n");
		      
		      /* Set value of links (copy) */
		      fprintf(AL_file,
			      "    contentcopy->%s = (void *) AL_HT_Search(ALint->AL_Mark, (unsigned long int) content->%s);\n",
			      field_decl->name, field_decl->name); 
		      
		      /* Endif (1) */
		      fprintf(AL_file, "  }\n\n");
		    }
		  }
		}
	      }
	    }
	  }
	}
	/* If we did not run into any copy making case */
	if (contentcopyused == 0) fprintf(AL_file, "  ((AL_Tp%d *) ALint->AL_Data[%d])[ALint->AL_DataCount[%d]] = *((AL_Tp%d *) content);\n\n", j, j, j, j);

	/* Add 1 to number of elements in DataCount */
	fprintf(AL_file, "  ALint->AL_DataCount[%d]++;\n", i);
	
	/* End of function */
	fprintf(AL_file, "\n  return (ALint->AL_DataCount[%d]);\n", i);
	fprintf(AL_file, "} /* _AL_CopyAdapt%d */\n\n", i);
      }
    }
    
    ////////////////////
    // Write _AL_Restore
    if (AM_log == 1) { 
      fprintf(logfile, "o Write _AL_Restore\n"); _AM_ff;
    }

    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file, 
	    /********************************************************/
	    "/*     _AL_Restore                                      */\n");
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file_H2, "void\n(* _AL_Restore[_AL_TpUsed])();\n\n");
    
    for (i = 0; i < root->yy_num_operands(); i++) { 
      decl = get_declaration(root, i);
      /* for each declaration in declaration list */
      
      if ((decl->Type == 1) || (decl->sType == 2)) { 
	/* if decclaration is an AM defined type */
	
	j = decl->datatype;
	fprintf(AL_file,
		"void\n_AL_Restore%d(AL_Tp%d *content, AL_Internals *ALint)\n", j, j);
	fprintf(AL_file, "{ /* _AL_Restore%d */\n", j);

	/* Find and get the real structure inside */
	decl2 = Search_Mirror(decl);
	tp = get_type(decl2);
	structure = get_struct(tp);
	for (k = 0; k < structure->num_fields; k++) { 
	  field = get_field(structure, k+1);
	  field_type = get_field_type(field);
	  for (l = 0; l < field->num_declarators; l++) { 
	    field_decl = get_field_decl(field, l+1);
	    /* Now if the it is a pointer ... */
	    if (field_decl->num_stars != 0) { 
	      for (m = 0; m < root->yy_num_operands(); m++) { 
		dummy = get_declaration(root, m);
		if ( (init_decl = get_init_decl(dummy)) != NULL ) { /*if */
		  if (strcmp(init_decl->name, field_type->name) == 0) { 
		    /* And it is a type we know of */

		    /* It is an array of pointers */
		    if (field_decl->is_array == 1) {
		      fprintf(AL_file, "  {\n    int i;\n\n");

		      fprintf(AL_file,
			      "    for (i = 0; i < %s; i++) {\n",
			      field_decl->array_size);

		      /* If child does not exist */
		      fprintf(AL_file, "      if ((void *) content->%s[i] == (void *) AL_NOCHILD) {\n",
			      field_decl->name);

		      /* Set child links to NULL */
		      fprintf(AL_file,
			      "        content->%s[i] = NULL;\n",
			      field_decl->name);

		      /* Else */
		      fprintf(AL_file, "      } else {\n");
		    
		      /* Recreate link */
		      fprintf(AL_file,
			      "         content->%s[i] = (void *) AL_SArray_GetValue(ALint->AL_Address, %d, (unsigned long int) content->%s[i]);\n", field_decl->name, dummy->datatype, field_decl->name);

		      /* Endif */
		      fprintf(AL_file, "      }\n");
		      
		      /* End for */
		    fprintf(AL_file, "    }\n  }\n\n");
		    } else {

		      /* If child does not exist */
		      fprintf(AL_file, "  if ((void *) content->%s == (void *) AL_NOCHILD) {\n",
			      field_decl->name);

		      /* Set child links to NULL */
		      fprintf(AL_file,
			      "    content->%s = NULL;\n",
			      field_decl->name);

		      /* Else */
		      fprintf(AL_file, "  } else {\n");
		      
		      /* Recreate link */
		      fprintf(AL_file,
			      "     content->%s = (void *) AL_SArray_GetValue(ALint->AL_Address, %d, (unsigned long int) content->%s);\n", field_decl->name, dummy->datatype, field_decl->name);

		      /* Endif */
		      fprintf(AL_file, "  }\n\n");
		    }
		  }
		}
	      }
	    }
	  }
	}
	fprintf(AL_file, "} /* _AL_Restore%d */\n\n", j);
      }
    }

    ////////////////////////////////////////////////////////////
    // Common operations
    
    ////////////////////
    // Write _AL_SetPacketSize
    if (AM_log == 1) { 
      fprintf(logfile, "o Write _AL_SetPacketSize\n"); _AM_ff;
    }

    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file, 
	    /********************************************************/
	    "/*     _AL_SetPacketSize                                */\n");
    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file_H2, "void\n(* _AL_SetPacketSize[_AL_TpUsed])();\n\n");
    
    for (i = 0; i < AM_dtnumber; i++) { 
      fprintf(AL_file,
	      "void\n_AL_SetPacketSize%d(int size)\n", i);
      fprintf(AL_file, "{ /* _AL_SetPacketSize%d */\n", i);
      fprintf(AL_file,
	      "  AL_PacketSize[%d] = (int) (size / sizeof(AL_Tp%d));\n",
	      i, i);
      fprintf(AL_file, "} /* _AL_SetPacketSize%d */\n\n", i);
    }
    
    ////////////////////
    // Write _AL_InitFunctions
    if (AM_log == 1) { 
      fprintf(logfile, "o Write _AL_InitFunctions "); _AM_ff;
    }

    fprintf(AL_file, "%s", AM_blank_comment);
    fprintf(AL_file, 
	    /********************************************************/
	    "/*     _AL_InitFunctions                                */\n");
    fprintf(AL_file, "%s", AM_blank_comment);
    
    fprintf(AL_file_H2, "void\n_AL_InitFunctions();\n\n");
    fprintf(AL_file, "void\n_AL_InitFunctions()\n");
    fprintf(AL_file, "{ /* _AL_InitFunctions */\n");
    for (i = 0; i < AM_dtnumber; i++) { /*for */
      fprintf(AL_file,
	      "  _AL_PrepareBuffer[%d] = _AL_PrepareBuffer%d;\n", i, i);
      fprintf(AL_file,
	      "  _AL_GetBlockBuffer[%d] = _AL_GetBlockBuffer%d;\n", i, i);
      fprintf(AL_file,
	      "  _AL_GiveBlockBuffer[%d] = _AL_GiveBlockBuffer%d;\n", i, i);
      fprintf(AL_file,
	      "  _AL_GetBlockElement[%d] = _AL_GetBlockElement%d;\n", i, i);
      fprintf(AL_file,
	      "  _AL_MemCreate[%d] = _AL_MemCreate%d;\n", i, i);
      fprintf(AL_file,
	      "  _AL_Traverse[%d] = _AL_Traverse%d;\n", i, i);
      fprintf(AL_file,
	      "  _AL_CopyAdapt[%d] = _AL_CopyAdapt%d;\n", i, i);
      fprintf(AL_file,
	      "  _AL_Restore[%d] = _AL_Restore%d;\n", i, i);
      fprintf(AL_file,
	      "  _AL_SetPacketSize[%d] = _AL_SetPacketSize%d;\n", i, i);
      fprintf(AL_file, "\n");
    }
    fprintf(AL_file, "} /* _AL_InitFunctions */\n");
    
    ////////////////////
    // Creation of "al_routines.inc" finished
    
    fprintf(AL_file_H2, "#endif\n");
    fclose(AL_file);
    fclose(AL_file_H2);

    if (AM_verbose == 1)
      cerr << "done"
	   << endl;
    
  }
  
  ////////////////////////////////////////////////////////////
  // Print output informations

  cout << "--> Generated output for :"
       << endl;

  for (i = 0; i < root->yy_num_operands(); i++) { 
      decl = get_declaration(root, i);
      /* for each declaration in declaration list */
      
      if ((decl->Type == 1) || (decl->sType > 0)) { 
	/* if decclaration is an AM defined type */
	
	init_decl = get_init_decl(decl);
	cout << "----> "
	     << init_decl->name;
	if (AM_verbose == 1) { 
	  cout << " (";
	  if (decl->Type == 1)
	    cout << "userType";
	  if (decl->sType > 0) { 
	    cout << "AutoMap";
	    if (decl->sType == 2)
	      cout << " and AutoLink";
	    cout << " subType";
	  }
	  cout << ")";
	}
	cout << endl;
      }
  }

  cout << "--> done"
       << endl;

  ////////////////////////////////////////////////////////////
  // Cleaning the AST
  if (AM_verbose == 1)
    cerr << "Cleaning the AST ... ";
  if (AM_log == 1) { 
    fprintf(logfile, "\n------------------------------------------------------------\nCleaning the AST\n"); _AM_ff;
  }

  yy_inp2 -> yy_inp_close(yy_true);
  yy_inp1 -> yy_inp_close(yy_true);
  
  delete	yy_parser1;
  delete	yy_lexer1;
  delete	yy_symtab1;
  delete	yy_inp1;
  
  delete	yy_parser2;
  delete	yy_lexer2;
  delete	yy_symtab2;
  delete	yy_inp2;
  
  if (AM_verbose == 1)
    cerr << "done"
	 << endl;
  
  ////////////////////
  // Closing log file
  if (AM_log == 1) { 
    if (AM_verbose == 1)
      cerr << "Closing log file ... ";
    
    fprintf(logfile, "o Closing log file\n");
    
    fclose(logfile);
    
    if (AM_verbose == 1)
      cerr << "done"
	   << endl;
  }
  
  printf("AutoMap finished without error\n\n");
  
  printf("Output files can be found in current directory.\n");
  if (AM_log == 1)
    printf("AutoMap remarks can be found in the logbook file.\n");
  
  yy_err_exit();
  
  delete	yy_err2;
  delete	yy_err1;
}
